Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -5554,21 +5847,890 @@
          var_flag = 0
       ENDIF
-   
-      DO  j = nys, nyn+1
-!
-!--      Determine vertical index of topography top at grid point (j,i)
+
+      IF  ( var == 'u' )  THEN
+!AH!
+!AH!--      Substitute the necessary parent-grid data to the work array workarrc_lr. 
+!AH         workarrc_lr = 0.0_wp     
+!AH         IF  ( pdims(2) > 1 )  THEN
+!AH#if defined( __parallel )
+!AH            IF  ( nys == 0 )  THEN 
+!AH               workarrc_lr(0:cg%nz+1,jcsw:jcnw-1,0:2)                           &
+!AH                    = fc(0:cg%nz+1,jcsw:jcnw-1,lbeg:lbeg+2)
+!AH            ELSE IF  ( nyn == ny )  THEN
+!AH               workarrc_lr(0:cg%nz+1,jcsw+1:jcnw,0:2)                           &
+!AH                    = fc(0:cg%nz+1,jcsw+1:jcnw,lbeg:lbeg+2)
+!AH            ELSE
+!AH               workarrc_lr(0:cg%nz+1,jcsw+1:jcnw-1,0:2)                         &
+!AH                    = fc(0:cg%nz+1,jcsw+1:jcnw-1,lbeg:lbeg+2)
+!AH            ENDIF
+!AH!
+!AH!--         South-north exchange if more than one PE subdomain in the y-direction.
+!AH!--         Note that in case of 3-D nesting the south (psouth == MPI_PROC_NULL) 
+!AH!--         and north (pnorth == MPI_PROC_NULL) boundaries are not exchanged 
+!AH!--         because the nest domain is not cyclic.
+!AH!--         From south to north
+!AH            CALL MPI_SENDRECV( workarrc_lr(0,jcsw+1,0), 1,                      &
+!AH                 workarrc_lr_exchange_type, psouth,  0,                         &
+!AH                 workarrc_lr(0,jcnw,0), 1,                                      &
+!AH                 workarrc_lr_exchange_type, pnorth,  0,                         &
+!AH                 comm2d, status, ierr ) 
+!AH!
+!AH!--         From north to south        
+!AH            CALL MPI_SENDRECV( workarrc_lr(0,jcnw-1,0), 1,                      &
+!AH                 workarrc_lr_exchange_type, pnorth,  1,                         &
+!AH                 workarrc_lr(0,jcsw,0), 1,                                      &
+!AH                 workarrc_lr_exchange_type, psouth,  1,                         &
+!AH                 comm2d, status, ierr )
+!AH#endif
+!AH         ELSE
+!AH            workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2)                                &
+!AH                 = fc(0:cg%nz+1,jcsw:jcnw,lbeg:lbeg+2)            
+!AH         ENDIF
+
+         DO  m = jcsw+1, jcnw-1
+            DO n = 0, kct 
+
+               DO  j = jfl(m), jfu(m)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,j,ibc) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'v' )  THEN
+         
+         DO  m = jcsw+1, jcnw-1
+            DO n = 0, kct 
+
+               DO  j = jfl(m), jfl(m+1)-1
+                  DO  k = kfl(n), kfu(n) 
+                     f(k,j,ibc) = fc(n,m,l) 
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'w' )  THEN
+
+         DO  m = jcsw+1, jcnw-1
+            DO n = 1, kct + 1   ! It is important to go up to kct+1  
+
+               DO  j = jfl(m), jfu(m)
+                  f(nzb,j,ibc) = 0.0_wp   ! Because the n-loop starts from n=1 instead of 0
+                  DO  k = kfu(n-1)+1, kfu(n) 
+                     f(k,j,ibc) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE   ! scalars
+         
+         DO  m = jcsw+1, jcnw-1
+            DO n = 0, kct 
+               
+               DO  j = jfl(m), jfu(m)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,j,ibc) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ENDIF  ! var
+
+   END SUBROUTINE pmci_interp_1sto_lr
+
+
+
+   SUBROUTINE pmci_interp_1sto_sn( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
+                                   r2z, logc, logc_ratio, logc_kbounds,        &
+                                   nzt_topo_nestbc,                            &
+                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
+                                   edge, var )
+
+!
+!--   Interpolation of ghost-node values used as the child-domain boundary
+!--   conditions. This subroutine handles the south and north boundaries. 
+!--   This subroutine is based on trilinear interpolation.
+
+      IMPLICIT NONE
+
+      INTEGER(iwp) ::  nzt_topo_nestbc   !<
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f             !<
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc            !<
+      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nxl:nxr),          &
+                                      INTENT(IN)    ::  logc_ratio    !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x           !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x           !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y           !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y           !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z           !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z           !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z           !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z           !<
+
+      
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic    !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc    !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc    !<
+      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nxl:nxr),                &
+                                          INTENT(IN)           ::  logc  !<
+      INTEGER(iwp), DIMENSION(1:2,nxl:nxr), INTENT(IN)         ::  logc_kbounds  !< 
+
+      INTEGER(iwp) :: kct
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
+      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
+      
+      INTEGER(iwp) ::  i        !< Running index in the x-direction
+      INTEGER(iwp) ::  iinc     !<
+      INTEGER(iwp) ::  icorr    !<
+      INTEGER(iwp) ::  ico      !<
+      INTEGER(iwp) ::  ierr     !< MPI error code
+      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
+      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
+      INTEGER(iwp) ::  i1       !<
+      INTEGER(iwp) ::  j        !< Lower bound of the running index ja
+      INTEGER(iwp) ::  ja       !< Index in y-direction running over the parent-grid cell on the boundary 
+      INTEGER(iwp) ::  jaw      !< Reduced ja-index for workarr_sn
+      INTEGER(iwp) ::  jawbc    !< jaw-index pointing to the boundary-value nodes (either 0 or jgsr-1)
+!AH      INTEGER(iwp) ::  jbeg     !< j-index pointing to the starting point of workarr_sn in the j-direction
+      INTEGER(iwp) ::  jbc      !< Fixed j-index pointing to the boundary-value nodes (either j or jend)
+      INTEGER(iwp) ::  jend     !< Upper bound of the running index ja
+      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
+      INTEGER(iwp) ::  k        !< Running index in the z-direction
+      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
+      INTEGER(iwp) ::  kcorr    !<
+      INTEGER(iwp) ::  kco      !<
+      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
+      INTEGER(iwp) ::  k1       !<
+      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
+      INTEGER(iwp) ::  lp1      !< l+1
+      INTEGER(iwp) ::  lrightu  !< Upshift by one for the upper bound of index l in case of var == 'u'
+      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
+      INTEGER(iwp) ::  mbeg     !< m-index pointing to the starting point of workarrc_sn in the m-direction 
+      INTEGER(iwp) ::  moff     !< m-offset needed on the north boundary to correctly refer to boundary ghost points
+      INTEGER(iwp) ::  mp1      !< m+1
+      INTEGER(iwp) ::  mw       !< Reduced m-index for workarrc_sn
+      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  np1      !< n+1
+      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
+      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
+
+      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
+      REAL(wp) ::  cellsumd     !< Sum of differences over the anterpolation cell 
+      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
+      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
+
+!
+!--   Check which edge is to be handled: south or north
+      IF ( edge == 's' )  THEN
+!
+!--      For v, nys is a ghost node, but not for the other variables
+         IF ( var == 'v' )  THEN
+            j     = nys
+            jend  = nys 
+            jawbc = 0
+            jbc   = nys
+            m     = jcs + 2
+            mw    = 2
+            mbeg  = jcs
+            moff  = 0
+         ELSE
+            j     = nys - jgsr
+            jend  = nys - 1
+            jawbc = jgsr - 1
+            jbc   = nys - 1
+            m     = jcs + 1
+            mw    = 1
+            mbeg  = jcs
+            moff  = 0
+         ENDIF
+      ELSEIF ( edge == 'n' )  THEN
+         IF ( var == 'v' )  THEN
+            j     = nyn + 1
+            jend  = nyn + 1
+            jawbc = 0
+            jbc   = nyn + 1
+            m     = jcn - 1
+            mw    = 1
+            mbeg  = jcn - 2
+            moff  = 0
+         ELSE
+            j     = nyn + 1
+            jend  = nyn + jgsr
+            jawbc = 0
+            jbc   = nyn + 1
+            m     = jcn - 1
+            mw    = 1
+            mbeg  = jcn - 2
+            moff  = 1
+         ENDIF
+      ENDIF
+
+      IF  ( var == 'w' )  THEN
+         ntopw = 1
+      ELSE
+         ntopw = 0
+      ENDIF
+
+      IF  ( var == 'u' )  THEN
+         lrightu = 0
+      ELSE
+         lrightu = 1
+      ENDIF
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+
+      IF  ( var == 'v' )  THEN
+!AH!
+!AH!--      Substitute the necessary parent-grid data to the work array workarrc_sn. 
+!AH         workarrc_sn = 0.0_wp     
+!AH         IF  ( pdims(1) > 1 )  THEN
+!AH#if defined( __parallel )
+!AH            IF  ( nxl == 0 )  THEN   ! if ( bc_dirichlet_l )
+!AH               workarrc_sn(0:cg%nz+1,0:2,iclw:icrw-1)                           &
+!AH                    = fc(0:cg%nz+1,mbeg:mbeg+2,iclw:icrw-1)
+!AH            ELSE IF  ( nxr == nx )  THEN    ! if ( bc_dirichlet_r )
+!AH               workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw)                           &
+!AH                    = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw)
+!AH            ELSE
+!AH               workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                         &
+!AH                    = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+!AH            ENDIF
+!AH!
+!AH!--         Left-right exchange if more than one PE subdomain in the x-direction.
+!AH!--         Note that in case of 3-D nesting the left (pleft == MPI_PROC_NULL) and 
+!AH!--         right (pright == MPI_PROC_NULL) boundaries are not exchanged because 
+!AH!--         the nest domain is not cyclic.
+!AH!--         From left to right
+!AH            CALL MPI_SENDRECV( workarrc_sn(0,0,iclw+1), 1,                      &
+!AH                 workarrc_sn_exchange_type, pleft,   0,                         &
+!AH                 workarrc_sn(0,0,icrw), 1,                                      &
+!AH                 workarrc_sn_exchange_type, pright,  0,                         &
+!AH                 comm2d, status, ierr ) 
+!AH!
+!AH!--         From right to left        
+!AH            CALL MPI_SENDRECV( workarrc_sn(0,0,icrw-1), 1,                      &
+!AH                 workarrc_sn_exchange_type, pright,  1,                         &
+!AH                 workarrc_sn(0,0,iclw), 1,                                      &
+!AH                 workarrc_sn_exchange_type, pleft,   1,                         &
+!AH                 comm2d, status, ierr )
+!AH#endif      
+!AH         ELSE
+!AH            workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                            &
+!AH                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+!AH         ENDIF
+
+         DO  l = iclw+1, icrw-1
+            DO n = 0, kct 
+
+               DO  i = ifl(l), ifu(l)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,jbc,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'u' )  THEN
+         
+         DO  l = iclw+1, icrw-1
+            DO n = 0, kct 
+               
+               DO  i = ifl(l), ifl(l+1)-1
+                  DO  k = kfl(n), kfu(n) 
+                     f(k,jbc,i) = fc(n,m,l) 
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'w' )  THEN
+
+         DO  l = iclw+1, icrw-1
+            DO n = 1, kct + 1   ! It is important to go up to kct+1  
+               
+               DO  i = ifl(l), ifu(l)
+                  f(nzb,jbc,i) = 0.0_wp   ! Because the n-loop starts from n=1 instead of 0
+                  DO  k = kfu(n-1)+1, kfu(n) 
+                     f(k,jbc,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE   ! scalars
+         
+         DO  l = iclw+1, icrw-1
+            DO n = 0, kct 
+               
+               DO  i = ifl(l), ifu(l)
+                  DO  k = kfl(n), kfu(n)
+                     f(k,jbc,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ENDIF  ! var
+
+   END SUBROUTINE pmci_interp_1sto_sn
+
+
+
+   SUBROUTINE pmci_interp_1sto_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,       &
+                                  r1z, r2z, kct, ifl, ifu, jfl, jfu, kfl, kfu, &
+                                  ijkfc, var )
+
+!
+!--   Interpolation of ghost-node values used as the child-domain boundary
+!--   conditions. This subroutine handles the top boundary. 
+!--   This subroutine is based on trilinear interpolation.
+
+      IMPLICIT NONE
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f     !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc    !< Parent-grid array
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x   !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x   !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y   !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y   !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z   !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z   !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z   !<
+
+      
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  ic    !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  jc    !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  kc    !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  kc    !<
+
+      INTEGER(iwp) :: kct
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) :: var   !<
+
+      INTEGER(iwp) ::  i    !<
+      INTEGER(iwp) ::  ib   !<
+      INTEGER(iwp) ::  iclc !< Lower i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  icrc !< Upper i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  ie   !<
+      INTEGER(iwp) ::  ierr !< MPI error code
+      INTEGER(iwp) ::  ijk  !<
+      INTEGER(iwp) ::  iw   !<
+      INTEGER(iwp) ::  j    !<
+      INTEGER(iwp) ::  jb   !<
+      INTEGER(iwp) ::  jcsc !< Lower j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  jcnc !< Upper j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  je   !< 
+      INTEGER(iwp) ::  jw   !<     
+      INTEGER(iwp) ::  k    !< Vertical child-grid index fixed to the boundary-value level 
+      INTEGER(iwp) ::  ka   !< Running vertical child-grid index
+      INTEGER(iwp) ::  kw   !< 
+      INTEGER(iwp) ::  l    !< Parent-grid index in x-direction
+      INTEGER(iwp) ::  lp1  !< l+1
+      INTEGER(iwp) ::  m    !< Parent-grid index in y-direction
+      INTEGER(iwp) ::  mp1  !< m+1
+      INTEGER(iwp) ::  n    !< Parent-grid work array index in z-direction
+      INTEGER(iwp) ::  np1  !< n+1
+      INTEGER(iwp) ::  noff !< n-offset needed on the top boundary to correctly refer to boundary ghost points  
+      INTEGER(iwp) ::  nw   !< n-index for workarrc_t
+      INTEGER(iwp) ::  var_flag  !<
+      
+      REAL(wp) ::  cellsum     !<
+      REAL(wp) ::  cellsumd    !<
+      REAL(wp) ::  fac
+      REAL(wp) ::  fk          !<
+      REAL(wp) ::  fkj         !<
+      REAL(wp) ::  fkjp        !<
+      REAL(wp) ::  fkpj        !<
+      REAL(wp) ::  fkpjp       !<
+      REAL(wp) ::  fkp         !<
+      REAL(wp) ::  rcorr       !<
+      REAL(wp) ::  rcorr_ijk   !<
+
+
+      IF ( var == 'w' )  THEN
+         k    = nzt
+         noff = 0
+      ELSE
+         k    = nzt + 1
+         noff = 1
+      ENDIF
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2      
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+      n  = kc(k) + noff
+      nw = 1 
+
+      IF  ( var == 'w' )  THEN
+!AH!
+!AH!--      Substitute the necessary parent-grid data to the work array. 
+!AH!--      Note that the dimension of workarrc_t is (0:2,jcsw:jcnw,iclw:icrw),
+!AH!--      And the jc?w and ic?w-index bounds depend on the location of the PE-
+!AH!--      subdomain relative to the side boundaries. 
+!AH         iclc = iclw + 1
+!AH         icrc = icrw - 1      
+!AH         jcsc = jcsw + 1
+!AH         jcnc = jcnw - 1
+!AH         IF  ( bc_dirichlet_l )  THEN
+!AH            iclc = iclw
+!AH         ENDIF
+!AH         IF  ( bc_dirichlet_r )  THEN
+!AH            icrc = icrw
+!AH         ENDIF
+!AH         IF  ( bc_dirichlet_s )  THEN
+!AH            jcsc = jcsw
+!AH         ENDIF
+!AH         IF  ( bc_dirichlet_n )  THEN
+!AH            jcnc = jcnw
+!AH         ENDIF
+!AH         workarrc_t = 0.0_wp
+!AH         workarrc_t(0:2,jcsc:jcnc,iclc:icrc)                                    &
+!AH              = fc(kc(k):kc(k)+2,jcsc:jcnc,iclc:icrc)
+!AH!
+!AH!--      Left-right exchange if more than one PE subdomain in the x-direction.
+!AH!--      Note that in case of 3-D nesting the left and right boundaries are 
+!AH!--      not exchanged because the nest domain is not cyclic.
+!AH#if defined( __parallel )
+!AH         IF  ( pdims(1) > 1 )  THEN
+!AH!
+!AH!--         From left to right
+!AH            CALL MPI_SENDRECV( workarrc_t(0,jcsw,iclw+1), 1,                    &
+!AH                 workarrc_t_exchange_type_y, pleft,  0,                         &
+!AH                 workarrc_t(0,jcsw,icrw), 1,                                    &
+!AH                 workarrc_t_exchange_type_y, pright, 0,                         &
+!AH                 comm2d, status, ierr ) 
+!AH!
+!AH!--         From right to left        
+!AH            CALL MPI_SENDRECV( workarrc_t(0,jcsw,icrw-1), 1,                    &
+!AH                 workarrc_t_exchange_type_y, pright, 1,                         &
+!AH                 workarrc_t(0,jcsw,iclw), 1,                                    &
+!AH                 workarrc_t_exchange_type_y, pleft,  1,                         &
+!AH                 comm2d, status, ierr )
+!AH         ENDIF
+!AH!
+!AH!--      South-north exchange if more than one PE subdomain in the y-direction.
+!AH!--      Note that in case of 3-D nesting the south and north boundaries are 
+!AH!--      not exchanged because the nest domain is not cyclic.
+!AH         IF  ( pdims(2) > 1 )  THEN
+!AH!
+!AH!--         From south to north         
+!AH            CALL MPI_SENDRECV( workarrc_t(0,jcsw+1,iclw), 1,                    &
+!AH                 workarrc_t_exchange_type_x, psouth, 2,                         &
+!AH                 workarrc_t(0,jcnw,iclw), 1,                                    &
+!AH                 workarrc_t_exchange_type_x, pnorth, 2,                         &
+!AH                 comm2d, status, ierr ) 
+!AH!
+!AH!--         From north to south        
+!AH            CALL MPI_SENDRECV( workarrc_t(0,jcnw-1,iclw), 1,                    &
+!AH                 workarrc_t_exchange_type_x, pnorth, 3,                         &
+!AH                 workarrc_t(0,jcsw,iclw), 1,                                    &
+!AH                 workarrc_t_exchange_type_x, psouth, 3,                         &
+!AH                 comm2d, status, ierr )
+!AH         ENDIF
+!AH#endif      
+!AH
+
+         DO  l = iclw+1, icrw-1
+            DO  m = jcsw+1, jcnw-1
+
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     f(k,j,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'u' )  THEN
+         
+         DO  l = iclw+1, icrw-1
+            DO  m = jcsw+1, jcnw-1
+               
+               DO  i = ifl(l), ifl(l+1)-1
+                  DO  j = jfl(m), jfu(m) 
+                     f(k,j,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE IF  ( var == 'v' )  THEN
+
+         DO  l = iclw+1, icrw-1
+            DO  m = jcsw+1, jcnw-1
+
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfl(m+1)-1
+                     f(k,j,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ELSE   ! scalars
+         
+         DO  l = iclw+1, icrw-1
+            DO  m = jcsw+1, jcnw-1
+
+               DO  i = ifl(l), ifu(l)
+                  DO  j = jfl(m), jfu(m)
+                     f(k,j,i) = fc(n,m,l)
+                  ENDDO
+               ENDDO
+
+            ENDDO
+         ENDDO
+
+      ENDIF  ! var
+
+   END SUBROUTINE pmci_interp_1sto_t
+
+
+
+   SUBROUTINE pmci_interp_tril_lr( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, &
+                                   r2z, logc, logc_ratio, logc_kbounds,        &
+                                   nzt_topo_nestbc,                            &
+                                   kct, ifl, ifu, jfl, jfu, kfl, kfu, ijkfc,   &
+                                   edge, var )
+!
+!--   Interpolation of ghost-node values used as the child-domain boundary
+!--   conditions. This subroutine handles the left and right boundaries. It is
+!--   based on trilinear interpolation.
+
+      IMPLICIT NONE
+
+      INTEGER(iwp) ::  nzt_topo_nestbc   !<
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f       !<
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc      !<
+      REAL(wp), DIMENSION(1:2,0:ncorr-1,nzb:nzt_topo_nestbc,nys:nyn),          &
+                                      INTENT(IN)    ::  logc_ratio   !<
+!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r1x     !<
+!AH      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)    ::  r2x     !<
+!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r1y     !<
+!AH      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)    ::  r2y     !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x     !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x     !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y     !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y     !<
+
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z     !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z     !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z     !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z     !<
+      
+
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic     !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc     !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc     !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc     !<
+      INTEGER(iwp), DIMENSION(1:2,nzb:nzt_topo_nestbc,nys:nyn),                &
+                                          INTENT(IN)           :: logc   !<
+      INTEGER(iwp), DIMENSION(1:2,nys:nyn), INTENT(IN)         :: logc_kbounds !<
+
+      INTEGER(iwp) :: kct
+
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH
+
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 'l', 'r', 's' or 'n' 
+      CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
+
+      INTEGER(iwp) ::  i        !< Lower bound of the running index ia
+      INTEGER(iwp) ::  ia       !< i-index running over the parent-grid cell on the boundary 
+      INTEGER(iwp) ::  iaw      !< Reduced ia-index for workarr_lr
+      INTEGER(iwp) ::  iawbc    !< iaw-index pointing to the boundary-value nodes (either 0 or igsr-1)      
+      INTEGER(iwp) ::  ibc      !< Fixed i-index pointing to the boundary-value nodes (either i or iend)
+!AH      INTEGER(iwp) ::  ibeg     !< i-index pointing to the starting point of workarr_lr in the i-direction 
+      INTEGER(iwp) ::  iend     !< Upper bound of the running index ia
+      INTEGER(iwp) ::  ierr     !< MPI error code
+      INTEGER(iwp) ::  ijk      !< Running index for all child-grid cells within the anterpolation cell
+      INTEGER(iwp) ::  iw       !< i-index for wall_flags_0
+      INTEGER(iwp) ::  j        !< Running index in the y-direction
+      INTEGER(iwp) ::  jco      !<
+      INTEGER(iwp) ::  jcorr    !<
+      INTEGER(iwp) ::  jinc     !<
+      INTEGER(iwp) ::  jw       !< j-index for wall_flags_0
+      INTEGER(iwp) ::  j1       !<
+      INTEGER(iwp) ::  k        !< Running index in the z-direction
+      INTEGER(iwp) ::  k_wall   !< Vertical index of topography top
+      INTEGER(iwp) ::  kco      !<
+      INTEGER(iwp) ::  kcorr    !<
+      INTEGER(iwp) ::  kw       !< k-index for wall_flags_0
+      INTEGER(iwp) ::  k1       !<
+      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
+      INTEGER(iwp) ::  lbeg     !< l-index pointing to the starting point of workarrc_lr in the l-direction 
+      INTEGER(iwp) ::  lp1      !< l+1
+      INTEGER(iwp) ::  loff     !< l-offset needed on the right boundary to correctly refer to boundary ghost points
+      INTEGER(iwp) ::  lw       !< Reduced l-index for workarrc_lr
+      INTEGER(iwp) ::  m        !< Parent-grid running index in the y-direction
+      INTEGER(iwp) ::  mnorthv  !< Upshift by one for the upper bound of index m in case of var == 'v'
+      INTEGER(iwp) ::  mp1      !< m+1
+      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  np1      !< n+1
+      INTEGER(iwp) ::  ntopw    !< Upshift by one for the upper bound of index n in case of var == 'w'
+      INTEGER(iwp) ::  var_flag !< Variable flag for BTEST( wall_flags_0 )
+
+      REAL(wp) ::  cellsum      !< Sum of child-grid node values over the anterpolation cell 
+      REAL(wP) ::  cellsumd     !< Sum of differences over the anterpolation cell 
+      REAL(wp) ::  fkj          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkjp         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpj         !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkpjp        !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fk           !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  fkp          !< Intermediate result in trilinear interpolation
+      REAL(wp) ::  rcorr        !< Average reversibility correction for the whole anterpolation cell
+      REAL(wp) ::  rcorr_ijk    !< Reversibility correction distributed to the individual child-grid nodes
+ 
+! 
+!--   Check which edge is to be handled
+      IF ( edge == 'l' )  THEN
+!
+!--      For u, nxl is a ghost node, but not for the other variables
+         IF ( var == 'u' )  THEN
+            i     = nxl
+            iend  = nxl
+            ibc   = nxl
+            iawbc = 0
+            lbeg  = icl
+            loff  = 0
+         ELSE
+            i     = nxl - igsr
+            iend  = nxl - 1
+            ibc   = nxl - 1
+            iawbc = igsr-1
+            lbeg  = icl
+            loff  = 0
+         ENDIF
+      ELSEIF ( edge == 'r' )  THEN
+         IF ( var == 'u' )  THEN
+            i     = nxr + 1            
+            iend  = nxr + 1
+            ibc   = nxr + 1 
+            iawbc = 0
+            lbeg  = icr - 2
+            loff  = 0
+         ELSE
+            i     = nxr + 1
+            iend  = nxr + igsr
+            ibc   = nxr + 1
+            iawbc = 0
+            lbeg  = icr - 2
+            loff  = 1
+         ENDIF
+
+      ENDIF
+
+      IF  ( var == 'w' )  THEN
+         ntopw = 1
+      ELSE
+         ntopw = 0
+      ENDIF
+
+      IF  ( var == 'v' )  THEN
+         mnorthv = 0
+      ELSE
+         mnorthv = 1
+      ENDIF
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+
+!AH
+!
+!--   Substitute the necessary parent-grid data to the work array workarrc_lr. 
+      workarrc_lr = 0.0_wp     
+      IF  ( pdims(2) > 1 )  THEN
+#if defined( __parallel )
+         IF  ( nys == 0 )  THEN 
+            workarrc_lr(0:cg%nz+1,jcsw:jcnw-1,0:2)                              &
+                 = fc(0:cg%nz+1,jcsw:jcnw-1,lbeg:lbeg+2)
+         ELSE IF  ( nyn == ny )  THEN
+            workarrc_lr(0:cg%nz+1,jcsw+1:jcnw,0:2)                              &
+                 = fc(0:cg%nz+1,jcsw+1:jcnw,lbeg:lbeg+2)
+         ELSE
+            workarrc_lr(0:cg%nz+1,jcsw+1:jcnw-1,0:2)                            &
+                 = fc(0:cg%nz+1,jcsw+1:jcnw-1,lbeg:lbeg+2)
+         ENDIF
+!
+!--      South-north exchange if more than one PE subdomain in the y-direction.
+!--      Note that in case of 3-D nesting the south (psouth == MPI_PROC_NULL) 
+!--      and north (pnorth == MPI_PROC_NULL) boundaries are not exchanged 
+!--      because the nest domain is not cyclic.
+!--      From south to north
+         CALL MPI_SENDRECV( workarrc_lr(0,jcsw+1,0), 1,                         &
+              workarrc_lr_exchange_type, psouth,  0,                            &
+              workarrc_lr(0,jcnw,0), 1,                                         &
+              workarrc_lr_exchange_type, pnorth,  0,                            &
+              comm2d, status, ierr ) 
+!
+!--      From north to south        
+         CALL MPI_SENDRECV( workarrc_lr(0,jcnw-1,0), 1,                         &
+              workarrc_lr_exchange_type, pnorth,  1,                            &
+              workarrc_lr(0,jcsw,0), 1,                                         &
+              workarrc_lr_exchange_type, psouth,  1,                            &
+              comm2d, status, ierr )
+#endif
+      ELSE
+         workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2)                                   &
+              = fc(0:cg%nz+1,jcsw:jcnw,lbeg:lbeg+2)            
+      ENDIF
+!
+!AH
+      workarr_lr = 0.0_wp
+      
+      DO  ia = i, iend
+         iaw = ia - i
+         DO  j = nys-1, nyn+1
+!AH         DO  j = nys, nyn
+!
+!--         Determine vertical index of topography top at grid point (j,i)
 !AH         k_wall = get_topography_top_index_ji( j, i, TRIM( var ) )
-
-         DO  k = nzb, nzt+1 !k_wall, nzt+1
-            l = ic(i)
-            m = jc(j)
-            n = kc(k)
-            fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
-            fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
-            fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
-            fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
-            fk       = r1y(j) * fkj  + r2y(j) * fkjp
-            fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
-            f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+            DO  k = nzb, nzt+1 !k_wall, nzt+1
+!AH               l   = ic(ia) - ic(i)
+               l   = ic(ia) - lbeg
+               lp1 = MIN( l + 1, 2 )  ! If l+1 > 2 (l=ic(nxr+1)-lbeg), r1x = 1 and r2x = 0
+               m   = jc(j)
+               mp1 = MIN( m + 1, jcnw )  ! If m+1 > jcn (m=jc(nyn+1)), r1y = 1 and r2y = 0
+               n   = kc(k)
+               np1 = n + 1            
+
+!AH
+!               fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
+!               fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
+!               fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
+!               fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
+!AH
+               
+               fkj      = r1x(ia) * workarrc_lr(n,m,l)     + r2x(ia) * workarrc_lr(n,m,lp1)
+               fkjp     = r1x(ia) * workarrc_lr(n,mp1,l)   + r2x(ia) * workarrc_lr(n,mp1,lp1)
+               fkpj     = r1x(ia) * workarrc_lr(np1,m,l)   + r2x(ia) * workarrc_lr(np1,m,lp1)
+               fkpjp    = r1x(ia) * workarrc_lr(np1,mp1,l) + r2x(ia) * workarrc_lr(np1,mp1,lp1)
+               
+               fk       = r1y(j) * fkj  + r2y(j) * fkjp
+               fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
+
+!AH
+!               f(k,j,i) = r1z(k) * fk + r2z(k) * fkp               
+               workarr_lr(k,j,iaw) = r1z(k) * fk + r2z(k) * fkp
+               
+!               if  ( ( edge == 'l' ) .and. ( ia  == ibc ) ) then
+!                  write(9,"('pmci_interp_tril_lr: ',a2,2x,11(i4,2x),7(e12.5,2x))") var, k, j, ia, ibc, iaw, n, m, l, np1, mp1, lp1, &
+!                       workarr_lr(k,j,iaw), r1x(ia), r2x(ia), workarrc_lr(n,m,l), workarrc_lr(n,mp1,l), workarrc_lr(np1,m,l), workarrc_lr(np1,mp1,l)
+!                  flush(9)
+!               endif
+
+!AH
+               
+            ENDDO
          ENDDO
       ENDDO
